#!/bin/python3

import sys
import itertools

fi = open('isosis.txt', 'rt')
fo = open('isoval.txt', 'wt')

ints = iter(map(int, fi.read().split()))

n = next(ints)
edges_a = [(next(ints), next(ints)) for _ in range(n-1)]
edges_b = set(((next(ints), next(ints)) for _ in range(n-1)))

def check(p):
	for a, b in edges_a:
		a, b = p[a], p[b]
		a, b = min(a, b), max(a, b)
		if (a, b) not in edges_b:
			return False
	return True

for p in itertools.permutations(range(n)):
	if check(p):
		fo.write('JAH\n')
		fo.write(' '.join(map(str, p))+'\n')
		fi.close()
		fo.close()
		sys.exit(0)

fo.write('EI\n')
fi.close()
fo.close()
sys.exit(0)
