# sisendi validaator

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

(v, e) = [int(_) for _ in fi.readline().split()]
if 1 > v or v > 50000:
	sys.exit('V out of range')
if 1 > e or e > 200000:
	sys.exit('E out of range')
fo.write('{0} {1}\n'.format(v, e))

s = set()
for i in range(e):
	(a, b) = [int(_) for _ in fi.readline().split()]
	if 1 > a or a > v:
		sys.exit('U[{0}] out of range'.format(1 + i))
	if 1 > b or b > v:
		sys.exit('V[{0}] out of range'.format(1 + i))
	if a == b:
		sys.exit('Self-loop on line {0}'.format(2 + i))
	if (a, b) in s or (b, a) in s:
		sys.exit('Duplicate street on line {0}'.format(2 + i))
	s.add((a, b))
	fo.write('{0} {1}\n'.format(a, b))

def root(x):
	global roots
	if roots[x] != x:
		roots[x] = root(roots[x])
	return roots[x]

def join(x, y):
	global roots
	roots[root(x)] = root(y)

roots = range(v)
for a, b in s:
	if root(a - 1) != root(b - 1):
		join(a - 1, b - 1)
for r in range(v):
	if root(r) != root(0):
		sys.exit('Street network not connected')

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if e < v and v <= 1000:
		print('subtask 1')
	elif e == v and v <= 1000:
		print('subtask 2')
	elif e < v:
		print('subtask 3')
	elif e == v:
		print('subtask 4')
	else:
		print('subtask 5')
