import sys

ints = iter(map(int, sys.stdin.read().split()))

n = next(ints)
edges_a = [(next(ints), next(ints)) for _ in range(n-1)]
edges_b = [(next(ints), next(ints)) for _ in range(n-1)]

print('graph { node [shape=circle]; edge [len=0.1];')
for i in range(n):
	print(f'a{i} [label={i}, color=red];')
	print(f'b{i} [label={i}, color=blue];')
for a, b in edges_a:
	print(f'a{a} -- a{b} [color=red];')
for a, b in edges_b:
	print(f'b{a} -- b{b} [color=blue];')
print('}')
