# sisendi validaator

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n = int(fi.readline().strip())
if 1 > n or n > 100000:
	sys.exit('N out of range')
fo.write('{0}\n'.format(n))

sys.setrecursionlimit(n + 50)

def root(x):
	global roots
	if roots[x] != x:
		roots[x] = root(roots[x])
	return roots[x]

def join(x, y):
	global roots
	roots[root(x)] = root(y)

roots = range(n)
for i in range(n - 1):
	(s, t) = [int(_) for _ in fi.readline().split()]
	if 0 > s or s >= t or t > n - 1:
		sys.exit('S,T out of range on line {0}'.format(2 + i))
	if root(s) == root(t):
		sys.exit('Loop detected on line {0}'.format(2 + i))
	join(s, t)
	fo.write('{0} {1}\n'.format(s, t))

roots = range(n)
for i in range(n - 1):
	(u, v) = [int(_) for _ in fi.readline().split()]
	if 0 > u or u >= v or v > n - 1:
		sys.exit('U,V out of range on line {0}'.format(n + 1 + i))
	if root(u) == root(v):
		sys.exit('Loop detected on line {0}'.format(n + 1 + i))
	join(u, v)
	fo.write('{0} {1}\n'.format(u, v))

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if n <= 20:
		print('subtask 1')
	elif n <= 1000:
		print('subtask 2')
	else:
		print('subtask 3')
