# sisendi validaator

import sys
import re

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

(h, w) = [int(_) for _ in fi.readline().split()]
if 1 > h or h > 100:
	sys.exit('H out of range')
if 1 > w or w > 100:
	sys.exit('W out of range')
fo.write('{0} {1}\n'.format(h, w))

m = 0
for i in range(h):
	s = fi.readline().strip('\n\r')
	if len(s) != w:
		sys.exit('Invalid line {0} length'.format(1 + i))
	for c in s:
		if c not in '.#@':
			sys.exit('Invalid line {0} content'.format(1 + i))
		if c == '@':
			m += 1
	fo.write('{0}\n'.format(s))

if m != 1:
	sys.exit('Invalid number of starting points')

fi.close()
fo.close()
