//Should get max points
//Should get partial points with diff checker
#include <bits/stdc++.h>
using namespace std;
typedef long long               ll;
const int mod = 1e9+7;
#ifndef M_PI
const double M_PI = acos(-1.0);
#endif

typedef vector<string> Map;
typedef pair<int, int> Loc;

int n, m;

bool on_border(Loc loc){
  return loc.first == 0 || loc.second == 0 || loc.first+1 == n || loc.second+1 == m;
}

int dist(Loc a, Loc b){
  return abs(a.first-b.first)+abs(a.second-b.second);
}

int main(){
  srand(time(NULL));
  ifstream fin("matksis.txt");
  ofstream fout("matkval.txt");
  fin>>n>>m;
  Map vis(n);
  getline(fin, vis[0]);
  for(int i=0; i<n; ++i){
    getline(fin, vis[i]);
  }
  Map start = vis;
  vector<tuple<int, Loc, Map> > bfs;
  for(int i=0; i<n; ++i){
    for(int j=0; j<m; ++j){
      if(vis[i][j] == '@'){
        Loc cur = {i, j};
        assert(bfs.empty());
        if(on_border(cur)){
          fout<<"0\n";
          for(int k=0; k<n; ++k){
            fout<<start[k]<<'\n';
          }
          return 0;
        }
        bfs.emplace_back(0, cur, vis);
      }
    }
  }
  for(int t=0; t<bfs.size(); ++t){
    int c_dist = get<0>(bfs[t])+1;
    Loc loc = get<1>(bfs[t]);
    int i_beg = 0, i_end = n;
    int i_dir = 1;
    if(rand()&1){
      i_beg = n-1;
      i_end = -1;
      i_dir = -1;
    }
    for(int i=i_beg; i != i_end; i += i_dir){
      int j_beg = 0, j_end = m;
      int j_dir = 1;
      if(rand()&1){
        j_beg = m-1;
        j_end = -1;
        j_dir = -1;
      }
      for(int j=j_beg; j != j_end; j += j_dir){
        Loc cur = {i, j};
        if(vis[i][j] == '.' && dist(loc, cur) == 1){
          vis[i][j] = '*';
          Map path = get<2>(bfs[t]);
          path[i][j] = '*';
          if(on_border(cur)){
            fout<<c_dist<<'\n';
            for(int k=0; k<n; ++k){
              fout<<path[k]<<'\n';
            }
            return 0;
          }
          bfs.emplace_back(c_dist, cur, path);
        }
      }
    }
  }
  fout<<"-1\n";
  for(int k=0; k<n; ++k){
    fout<<start[k]<<'\n';
  }
	return 0;
}
