import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

(n, k) = [int(_) for _ in fi.readline().split()]
if 1 > n or n > 20:
	sys.exit('N out of range')
if 0 > k or k > n:
	sys.exit('K out of range')
fo.write('{0} {1}\n'.format(n, k))

x = [int(_) for _ in fi.readline().split()]
if len(x) != k:
	sys.exit('Invalid number of X servers')
for i in range(k):
	if 1 > x[i] or x[i] > n:
		sys.exit('X[{0}] server number out of range'.format(1 + i))
	if i > 0 and x[i - 1] >= x[i]:
		sys.exit('X server numbers not increasing')
fo.write('{0}\n'.format(' '.join(map(str, x))))

fi.close()
fo.close()
