# -- coding: utf-8 --
# Ülesanne 'Serverite kolimine'

import sys 

def play(pfrom, pto, a, b, c, fo):
	if pfrom == 'A':
		if pto == 'B':
			b.append(a.pop())
		else:
			c.append(a.pop())
	elif pfrom == 'B':
		if pto == 'A':
			a.append(b.pop())
		else:
			c.append(b.pop())
	elif pfrom == 'C':
		if pto == 'A':
			a.append(c.pop())
		else:
			b.append(c.pop())

def move(pfrom, pto, aux, n, m, a, b, c, fo):
	if n == 1:
		print(pfrom + '->' + pto, file=fo)
		play(pfrom, pto, a, b, c, fo)
	elif n > 1:
		move(pfrom, aux, pto, n-1, m, a, b, c, fo)
		if(pfrom == 'A' and pto == 'C'):
		    print(pfrom + '->' + 'A', file=fo)
		else:
		    print(pfrom + '->' + pto, file=fo)
		play(pfrom, pto, a, b, c, fo)
		if n == m:
			i = 0
			while ((aux == 'B' and len(b)>i and b[i].startswith('X')) or (aux == 'C' and len(c)>i and c[i].startswith('Y'))):
				i += 1
			if aux == 'B' and len(b)>i:
				move('B', 'C', 'A', len(b)-i, len(b)-i, a, b, c, fo)
			elif aux == 'C' and len(c)>i:
				move('C', 'B', 'A', len(c)-i, len(c)-i, a, b, c, fo)
			elif aux == 'A' and len(a)>0:
				if a[0].startswith('X'):
					move('A', 'B', 'C', n-1, m-1, a, b, c, fo)
				elif a[0].startswith('Y'):
					move('A', 'C', 'B', n-1, m-1, a, b, c, fo)
		else:
			move(aux, pto, pfrom, n-1, m-1, a, b, c, fo)

infile = 'servsis.txt'
if len(sys.argv) >= 2:
	infile = sys.argv[1]
outfile = 'servval.txt'
if len(sys.argv) >= 3:
	outfile = sys.argv[2]

with open(infile, 'r') as f, open(outfile, 'w') as fout:
	n, k = map(int, f.readline().split())
	x_line = f.readline().split()
	A = []
	B = []
	C = []
	for i in range(n):
		if str(i+1) in x_line: A.insert(0, 'X'+str(i+1))
		else: A.insert(0, 'Y'+str(i+1))
	if A[0].startswith('X'):
		move('A', 'B', 'C', n, n, A, B, C, fout)
	else:
		move('A', 'C', 'B', n, n, A, B, C, fout)
